#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

namespace IvHelpers
{
	public class FirstTick
	{
		public bool IsFirstTick{get;set;}
		public int	CurrentBar{get;set;}
		public int	PreviousBar{get;set;}
		
		public FirstTick(int CurrentBar)
		{
			this.CurrentBar = CurrentBar;
		}
		
		public void Update(int CurrentBar)
		{
			this.CurrentBar = 	CurrentBar;
			IsFirstTick		=	PreviousBar < CurrentBar;
			PreviousBar 	= 	Math.Max(CurrentBar,PreviousBar);
		}
	}
	
	public class TimeFilter
    {
        public TimeSpan StartTime { get; set; }
        public TimeSpan EndTime { get; set; }

        public bool Enabled { get; set; }

        public TimeFilter(TimeSpan StartTime, TimeSpan EndTime, bool Enabled)
        {
            this.StartTime = StartTime;
            this.Enabled = Enabled;
            this.EndTime = EndTime;
        }

        public bool IsValidTime(DateTime time)
        {
            TimeSpan dayTime = time.TimeOfDay;
            if (StartTime < EndTime)
            {
                if (dayTime >= StartTime && dayTime <= EndTime)
                    return (true);
            }
            else if (StartTime > EndTime)
            {
                if (dayTime >= StartTime || dayTime <= EndTime)
				{
                    return (true);
				}
            }
            else
			{
                return (true);
			}

            return (false);
        }
    }
	
}




