#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

namespace NinjaTrader.NinjaScript.Indicators
{
	public class Level3Semafor : Indicator
	{
		
		[Range(1, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Period", GroupName = "Parameters", Order = 1)]
		public int Period1
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Dev1", GroupName = "Parameters", Order = 2)]
		public double Dev1
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Step1", GroupName = "Parameters", Order = 3)]
		public int Step1
		{ get; set; }
		
		[Range(1, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Period2", GroupName = "Parameters", Order = 4)]
		public int Period2
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Dev2", GroupName = "Parameters", Order = 5)]
		public double Dev2
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Step2", GroupName = "Parameters", Order = 6)]
		public int Step2
		{ get; set; }
		
		[Range(1, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Period3", GroupName = "Parameters", Order = 7)]
		public int Period3
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Dev3", GroupName = "Parameters", Order = 8)]
		public double Dev3
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Step3", GroupName = "Parameters", Order = 9)]
		public int Step3
		{ get; set; }
		
		
		
		
		
//		[Range(0, int.MaxValue), NinjaScriptProperty]
//		[Display(Name = "Dev1_Step1_2", GroupName = "Parameters", Order = 5)]
//		public double Dev1_Step1_2
//		{ get; set; }
		
//		[Range(0, int.MaxValue), NinjaScriptProperty]
//		[Display(Name = "Dev1_Step1_3", GroupName = "Parameters", Order = 6)]
//		public double Dev1_Step1_3
//		{ get; set; }
		
		[Browsable(false)]
		public Series<double> HP_ZZ
		{
			get{return Values[2];}
		}
		
		[Browsable(false)]
		public Series<double> NP_ZZ
		{
			get{return Values[1];}
		}
		
		IvHelpers.FirstTick	bar0FT;
		int	idx	=	0;
		
		Series<double>	FP_LowSeries;
		Series<double>	FP_HighSeries;
		Series<double>	NP_LowSeries;
		Series<double>	NP_HighSeries;
		Series<double>	HP_LowSeries;
		Series<double>	HP_HighSeries;
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"";
				Name										= "Level3Semafor";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= true;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				IsSuspendedWhileInactive					= false;
				
				Period1										= 5;
				Period2										= 13;
				Period3										= 34;
				Dev1										= 1;
				Dev2										= 8;
				Dev3										= 21;
				Step1										= 3;
				Step2										= 5;
				Step3										= 12;
				
				
//				AddPlot(new Stroke(Brushes.Transparent,3),PlotStyle.Dot,"Up FP");
//				AddPlot(new Stroke(Brushes.Transparent,3),PlotStyle.Dot,"Dn FP");
				AddPlot(new Stroke(Brushes.Chocolate,3),PlotStyle.Dot,"ZZ FP");
				
//				AddPlot(new Stroke(Brushes.Transparent,6),PlotStyle.Dot,"Up NP");
//				AddPlot(new Stroke(Brushes.Transparent,6),PlotStyle.Dot,"Dn NP");
				AddPlot(new Stroke(Brushes.MediumVioletRed,6),PlotStyle.Dot,"ZZ NP");
				
//				AddPlot(new Stroke(Brushes.Transparent,8),PlotStyle.Dot,"Up HP");
//				AddPlot(new Stroke(Brushes.Transparent,8),PlotStyle.Dot,"Dn HP");
				AddPlot(new Stroke(Brushes.Yellow,8),PlotStyle.Dot,"ZZ HP");
				
				
				
			}
			else if (State == State.Configure)
			{
			}
			else if (State == State.DataLoaded)
			{
				bar0FT	=	new IvHelpers.FirstTick(CurrentBars[0]);
				
				FP_LowSeries	=	new Series<double>(this,MaximumBarsLookBack.Infinite);
				FP_HighSeries	=	new Series<double>(this,MaximumBarsLookBack.Infinite);
				NP_LowSeries	=	new Series<double>(this,MaximumBarsLookBack.Infinite);
				NP_HighSeries	=	new Series<double>(this,MaximumBarsLookBack.Infinite);
				HP_LowSeries	=	new Series<double>(this,MaximumBarsLookBack.Infinite);
				HP_HighSeries	=	new Series<double>(this,MaximumBarsLookBack.Infinite);
				
			}
		}

		
		
		protected override void OnBarUpdate()
		{
			bar0FT.Update(CurrentBars[0]);
			
			idx	=	State==State.Historical || Calculate == Calculate.OnBarClose ? 0 : 1;
			
			if(bar0FT.IsFirstTick)
			{
				CountZZ(FP_LowSeries,FP_HighSeries,Values[0],Period1,Dev1,Step1);
				CountZZ(NP_LowSeries,NP_HighSeries,Values[1],Period2,Dev2,Step2);
				CountZZ(HP_LowSeries,HP_HighSeries,Values[2],Period3,Dev3,Step3);
			}
		}
		
		
		
		private	void CountZZ(Series<double> lowSeries,Series<double> highSeries,Series<double> zSeries,int Period1, double Dev1, int Step1)
		{
			int 	lasthighpos	=	0, 	lastlowpos	=	0;
			double	val			=	0,	res			=	0;
			double 	curlow		=	0,	curhigh		=	0,	lasthigh	=	0,lastlow	=	0;
			int 	limit		=	0,	j			=	0, 	counterZ	=	0;	
			
			int whatlookfor		=	0;
			
			if(CurrentBars[0] >= Closes[0].Count-2)
			{

				if(CurrentBars[0]==Closes[0].Count-2 && State==State.Historical)
				{
					for(int n=0;n<CurrentBars[0];n++)
					{
						zSeries.Reset(n);
						lowSeries.Reset(n);
						highSeries.Reset(n);
					}
					limit	=	CurrentBars[0]-Period1;
				}
				else	
				{
					j = counterZ	=	0;
					while(counterZ < 3 && j < Math.Min(CurrentBars[0],100))
					{
						if(zSeries.IsValidDataPoint(j))
							counterZ++;
						j++;
					}
					
					
					//--- no extremum found - recounting all from begin
					if(counterZ==0)
					{
						for(int n=0;n<CurrentBars[0];n++)
						{
							zSeries.Reset(n);
							lowSeries.Reset(n);
							highSeries.Reset(n);
						}
						
						limit=CurrentBars[0]-Period1;
					}
					else
					{
						//--- set start position to found extremum position
						limit=j-1;
						//--- what kind of extremum?
						if(lowSeries[0]!=0) 
						{
							//--- low extremum
							curlow=lowSeries[j];
							//--- will look for the next high extremum
							whatlookfor=1;
						}
						else
						{
						//--- high extremum
							curhigh=highSeries[j];
							//--- will look for the next low extremum
							whatlookfor=-1;
						}
						//--- clear the rest data
						for(j=limit-1; j>=0; j--)  
						{
							zSeries.Reset(j);  
							lowSeries.Reset(j);
							highSeries.Reset(j);
						}
					}
		     
				}
				
				
				
				for(j = limit; j >= 0; j--)
				{
					//LOW
					val = MIN(Lows[0],Period1)[j];
					
					if(val.CompareTo(lastlow)==0)
					{
						val	=	0;
					}
					else
					{
						lastlow = val;
						if(Lows[0][j] - val > (Dev1*TickSize))
						{
								val = 0;
						}
						else
						{
							for(int back = 1; back <= Step1; back++)
							{
								if(lowSeries.IsValidDataPoint(Math.Min(CurrentBars[0],(j+back))) && lowSeries[Math.Min(CurrentBars[0],(j+back))] > val)
								{
									lowSeries.Reset(Math.Min(CurrentBars[0],(j+back)));
								}
							}
						}
					}
					
					if(Lows[0][j].CompareTo(val) == 0) 
					{ 
						lowSeries[j] = val;
					} 
					else  
					{
						lowSeries.Reset(j);
					}
					
					
					//HIGH
					
					val = MAX(Highs[0],Period1)[j];
					
					if(val.CompareTo(lasthigh)==0)
					{
						val	=	0;
					}
					else
					{
						lasthigh = val;
						if(val - Highs[0][j] > (Dev1*TickSize))
								val = 0;
						else
						{
							for(int back = 1; back <= Step1; back++)
							{
								if(highSeries.IsValidDataPoint(Math.Min(CurrentBars[0],(j+back))) && highSeries[Math.Min(CurrentBars[0],(j+back))] < val)
								{
									highSeries[Math.Min(CurrentBars[0],(j+back))] = 0;
								}
							}
						}
					}
					
					
					
					if(val.CompareTo(Highs[0][j]) == 0) 
					{ 
						highSeries[j] = val;
						
					} 
					else  
					{
						highSeries.Reset(j);
					}
					
					
					
				}
					
				if(whatlookfor==0)
				{
					lastlow		=	0.0;
					lasthigh	=	0.0;  
				}
				else
				{
					lastlow		=	curlow;
					lasthigh	=	curhigh;
				}
					
				for(j = limit; j >= 0; j--)
				{	
					switch(whatlookfor)
					{
						case 0: // look for peak or lawn 
						if(lastlow==0.0 && lasthigh==0.0)
						{
							if(highSeries.IsValidDataPoint(j))
							{
								lasthigh			=	Highs[0][j];
								lasthighpos			=	j;
								whatlookfor			=	-1;
								if(lasthigh==0)
									zSeries.Reset(j);
								else
									zSeries[j]		=	lasthigh;
								
							}
							if(lowSeries.IsValidDataPoint(j))
							{
								lastlow				=	Lows[0][j];
								lastlowpos			=	j;
								whatlookfor			=	1;
								if(lastlow==0)
									zSeries.Reset(j);
								else
									zSeries[j]			=	lastlow;
								
							}
						}
						break;  
						case 1: // look for peak
						if(lowSeries.IsValidDataPoint(j) && lowSeries[j]<lastlow && !highSeries.IsValidDataPoint(j))
						{
							zSeries.Reset(lastlowpos);
							lastlowpos								=	j;
							lastlow									=	lowSeries[j];
							if(lastlow==0)
								zSeries.Reset(j);
							zSeries[j]			=	lastlow;
						}
						if(highSeries.IsValidDataPoint(j) && !lowSeries.IsValidDataPoint(j))
						{
							lasthigh			=	highSeries[j];
							lasthighpos			=	j;
							if(lasthigh==0)
								zSeries.Reset(j);
							else
								zSeries[j]		=	lasthigh;
							whatlookfor			=	-1;
						}   
						break;               
						case -1: // look for lawn
						if(highSeries.IsValidDataPoint(j) && highSeries[j]>lasthigh && !lowSeries.IsValidDataPoint(j))
						{
							zSeries.Reset(lasthighpos);
							lasthighpos									=	j;
							lasthigh									=	highSeries[j];
							if(lasthigh==0)
								zSeries.Reset(j);
							else
								zSeries[j]		=	lasthigh;
						}
						if(lowSeries.IsValidDataPoint(j) && !highSeries.IsValidDataPoint(j))
						{
							lastlow				=	lowSeries[j];
							lastlowpos			=	j;
							if(lastlow==0)
								zSeries.Reset(j);
							else
								zSeries[j]			=	lastlow;
							whatlookfor			=	1;
						}   
						break;  
					}
				}
				
				
			}
			
		}
		
	




  
  
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private Level3Semafor[] cacheLevel3Semafor;
		public Level3Semafor Level3Semafor(int period1, double dev1, int step1, int period2, double dev2, int step2, int period3, double dev3, int step3)
		{
			return Level3Semafor(Input, period1, dev1, step1, period2, dev2, step2, period3, dev3, step3);
		}

		public Level3Semafor Level3Semafor(ISeries<double> input, int period1, double dev1, int step1, int period2, double dev2, int step2, int period3, double dev3, int step3)
		{
			if (cacheLevel3Semafor != null)
				for (int idx = 0; idx < cacheLevel3Semafor.Length; idx++)
					if (cacheLevel3Semafor[idx] != null && cacheLevel3Semafor[idx].Period1 == period1 && cacheLevel3Semafor[idx].Dev1 == dev1 && cacheLevel3Semafor[idx].Step1 == step1 && cacheLevel3Semafor[idx].Period2 == period2 && cacheLevel3Semafor[idx].Dev2 == dev2 && cacheLevel3Semafor[idx].Step2 == step2 && cacheLevel3Semafor[idx].Period3 == period3 && cacheLevel3Semafor[idx].Dev3 == dev3 && cacheLevel3Semafor[idx].Step3 == step3 && cacheLevel3Semafor[idx].EqualsInput(input))
						return cacheLevel3Semafor[idx];
			return CacheIndicator<Level3Semafor>(new Level3Semafor(){ Period1 = period1, Dev1 = dev1, Step1 = step1, Period2 = period2, Dev2 = dev2, Step2 = step2, Period3 = period3, Dev3 = dev3, Step3 = step3 }, input, ref cacheLevel3Semafor);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.Level3Semafor Level3Semafor(int period1, double dev1, int step1, int period2, double dev2, int step2, int period3, double dev3, int step3)
		{
			return indicator.Level3Semafor(Input, period1, dev1, step1, period2, dev2, step2, period3, dev3, step3);
		}

		public Indicators.Level3Semafor Level3Semafor(ISeries<double> input , int period1, double dev1, int step1, int period2, double dev2, int step2, int period3, double dev3, int step3)
		{
			return indicator.Level3Semafor(input, period1, dev1, step1, period2, dev2, step2, period3, dev3, step3);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.Level3Semafor Level3Semafor(int period1, double dev1, int step1, int period2, double dev2, int step2, int period3, double dev3, int step3)
		{
			return indicator.Level3Semafor(Input, period1, dev1, step1, period2, dev2, step2, period3, dev3, step3);
		}

		public Indicators.Level3Semafor Level3Semafor(ISeries<double> input , int period1, double dev1, int step1, int period2, double dev2, int step2, int period3, double dev3, int step3)
		{
			return indicator.Level3Semafor(input, period1, dev1, step1, period2, dev2, step2, period3, dev3, step3);
		}
	}
}

#endregion
