#region Using declarations
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.Indicators;
using NinjaTrader.NinjaScript.DrawingTools;
using System.IO;
using System.Windows.Media.Imaging;
using System.Windows.Automation;
#endregion

namespace NinjaTrader.NinjaScript.Strategies
{
	[Gui.CategoryOrder("Parameters", 1)] 
	[Gui.CategoryOrder("StopLoss", 2)] 
	[Gui.CategoryOrder("Session PnL", 6)] 
	[Gui.CategoryOrder("SMA Filter", 8)] 
	
	public class SemaforStrategy4 : Strategy
	{
		
		
		public override string DisplayName { get { return "Semafor Strategy 4"; } }
		
		#region Variables
		
		
		
		Order				stopOrder1, entryOrder1, entryOrder2, entryOrder3, stopOrder2, stopOrder3;
		bool				stopWasPlaced1,stopWasPlaced2,stopWasPlaced3;
		bool				entryWasPlaced;
		bool				wasClosed;
		int					addStopQuant1,addStopQuant2,addStopQuant3;
		int					addProfitQuant1,addProfitQuant2,addProfitQuant3;
		FirstTick			bar0FT;	
		bool				StrategyEnabled;
		double				lastTrailStop;
		double				prevSessionsPnl;
		List<TimeFilter>	timeFilters									=	new List<TimeFilter>();
		
		Order				profit1Order,profit2Order,profit3Order,profit4Order;
		bool				profit1WasPlaced,profit2WasPlaced,profit3WasPlaced,profit4WasPlaced;
		bool				wasBreakeven;
		bool				slmEntryWasPlaced;
		bool				profitWasPlaced;
		
		bool								AddProfits						=	false;
		
		bool								IsMaxProfitStopReached			=	false;
		bool								closeTradePerSessionPnl			=	false;
		
		int 								idx								=	0;
		
		
		
		bool								buyYellow,buyPurple,sellYellow,sellPurple;
		bool								reverse		=	false;
		
		int									profitQTotal;
		int									tradeBar;
		int									pos				=	0;
		
		bool								extbar			=	false;
		
	
		
		bool								closePosition;
		
		Level3Semafor						level3Semafor;
		
		int									stopState;
		
		bool								wasTrailTrigger1, wasTrailTrigger2, wasTrailTrigger3;
		
//		int									Quantity	=	0;
		
		int									quantit		=	0;
		
		#endregion
		
		#region Properties
		
		#region Parameters
		
//		[Browsable(false)]
//		[NinjaScriptProperty]
//		[Range(1,Int32.MaxValue)]
//		[Display(Name = "Quantity", Order = 1, GroupName = "Parameters")]
//        public int EntryQuantity
//        {
//            get;set;
//        }
		
//		[NinjaScriptProperty]
//		[Range(0,Int32.MaxValue)]
//		[Display(Name = "Strategy Profit", Order = 2, GroupName = "Parameters")]
//        public double StrategyProfit
//        {
//            get;set;
//        }
		
		[Browsable(false)]
		[NinjaScriptProperty]
		[Display(Name = "Historical", Order = 3, GroupName = "Parameters")]
        public bool IsHistorical
        {
            get;set;
        }
		
		
		#endregion
		
		#region ATM
		
		[NinjaScriptProperty]
		[Range(0,Int32.MaxValue)]
		[Display(Name = "Yellow Dot %", Order = 1, GroupName = "Trading Parameters")]
        public double YellowDotQuantity
        {
            get;set;
        }
		
		[NinjaScriptProperty]
		[Range(0,Int32.MaxValue)]
		[Display(Name = "Purple Dot %", Order = 2, GroupName = "Trading Parameters")]
        public double PurpleDotQuantity
        {
            get;set;
        }
		
		
		[NinjaScriptProperty]
		[Range(0,Int32.MaxValue)]
		[Display(Name = "Profit Target", Order = 3, GroupName = "Trading Parameters")]
        public double PT
        {
            get;set;
        }
		
		
		
		#endregion
		
		#region Session PnL
		
//		[RefreshProperties(RefreshProperties.All)]
//		[NinjaScriptProperty]
//		[Display(Name="Session PnL", Description="Activate Session PnL", Order=1, GroupName="Session PnL")]
//		public bool IsSessionPnLEnabled
//		{ get; set; }
		
//		[NinjaScriptProperty]
//		[Range(1, int.MaxValue)]
//		[Display(Name="PerSessionProfitTarget", Description="Max Profit per session", Order=2, GroupName="Session PnL")]
//		public int PerSessionProfitTarget
//		{ get; set; }

//		[NinjaScriptProperty]
//		[Range(1, int.MaxValue)]
//		[Display(Name="PerSessionStopLoss", Description="Max Loss Per Session", Order=3, GroupName="Session PnL")]
//		public int PerSessionStopLoss
//		{ get; set; }
		
		
		#endregion
		
		#region Indicator Parameters
		
		[Range(1, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Period", GroupName = "Semafor Parameters", Order = 1)]
		public int Period1
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Dev1", GroupName = "Semafor Parameters", Order = 2)]
		public double Dev1
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Step1", GroupName = "Semafor Parameters", Order = 3)]
		public int Step1
		{ get; set; }
		
		[Range(1, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Period2", GroupName = "Semafor Parameters", Order = 4)]
		public int Period2
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Dev2", GroupName = "Semafor Parameters", Order = 5)]
		public double Dev2
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Step2", GroupName = "Semafor Parameters", Order = 6)]
		public int Step2
		{ get; set; }
		
		[Range(1, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Period3", GroupName = "Semafor Parameters", Order = 7)]
		public int Period3
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Dev3", GroupName = "Semafor Parameters", Order = 8)]
		public double Dev3
		{ get; set; }
		
		[Range(0, int.MaxValue), NinjaScriptProperty]
		[Display(Name = "Step3", GroupName = "Semafor Parameters", Order = 9)]
		public int Step3
		{ get; set; }
		
		#endregion
		
		#endregion
		
		#region OnStateChange
		
		protected override void OnStateChange()
		{
			#region SetDefaults
			
			if (State == State.SetDefaults)
			{
				Description									= @"";
				Name										= "Semafor Strategy 4";
				Calculate									= Calculate.OnBarClose;
				EntriesPerDirection							= 1;
				EntryHandling								= EntryHandling.AllEntries;
				IsExitOnSessionCloseStrategy				= true;
				ExitOnSessionCloseSeconds					= 930;
				IsFillLimitOnTouch							= false;
				MaximumBarsLookBack							= MaximumBarsLookBack.TwoHundredFiftySix;
				OrderFillResolution							= OrderFillResolution.Standard;
				Slippage									= 0;
				StartBehavior								= StartBehavior.WaitUntilFlat;
				TimeInForce									= TimeInForce.Gtc;
				TraceOrders									= false;
				RealtimeErrorHandling						= RealtimeErrorHandling.IgnoreAllErrors;
				StopTargetHandling							= StopTargetHandling.PerEntryExecution;
				BarsRequiredToTrade							= 20;
				IsInstantiatedOnEachOptimizationIteration	= true;
				IsUnmanaged									= true;
				IsAutoScale									= false;
				
				
//				PerSessionProfitTarget						= 1000;
//				PerSessionStopLoss							= 1000;
				
//				EntryQuantity								= 1;
				
				
				Period1										= 5;
				Period2										= 13;
				Period3										= 34;
				Dev1										= 1;
				Dev2										= 8;
				Dev3										= 21;
				Step1										= 3;
				Step2										= 5;
				Step3										= 12;
              
//				IsHistorical								= false;
//				StrategyProfit								= 1100;
				
				YellowDotQuantity							= 1;
				PurpleDotQuantity							= 1;
				PT											= 5;
			}
			
			#endregion
			
			#region Configure
			
			else if (State == State.Configure)
			{
				
			}
			
			#endregion
			
			#region DataLoaded
			
			else if(State==State.DataLoaded)
			{
				
				
				bar0FT				=	new FirstTick(CurrentBars[0]);
				
				StrategyEnabled 	= 	IsHistorical;
				
				level3Semafor		=	Level3Semafor(Period1,Dev1,Step1,Period2,Dev2,Step2,Period3,Dev3,Step3);
				
				AddChartIndicator(level3Semafor);
				
//				Quantity			=	EntryQuantity;
			}
			
			#endregion
			
			#region Transition
			
			else if (State==State.Transition)
			{
				StrategyEnabled	=	!StrategyEnabled;
			}
			
			#endregion
			
			#region Historical
			
			else if(State==State.Historical)
			{
				
			}
			
			#endregion
			
			#region Terminated
			
			else if(State == State.Terminated)
			{
				
			}
			
			#endregion
		}
		
		#endregion

		#region OnBarUpdate
		
		protected override void OnBarUpdate()
		{
			
			if(BarsInProgress == 0)
			{
				bar0FT.Update(CurrentBars[0]);
			}
			
			
			if(!StrategyEnabled)
				return;
			
			idx		=	(Calculate==Calculate.OnBarClose || State==State.Historical) ? 0 : 1;
			
			if(CurrentBars[0] < BarsRequiredToTrade )
				return;
			
			
		   	if(Bars.IsFirstBarOfSession && bar0FT.IsFirstTick)
			{
				if(IsExitOnSessionCloseStrategy)
				{
					pos	=	0;
					ResetOrders();
				}
				
				prevSessionsPnl			=	SystemPerformance.AllTrades.TradesPerformance.Currency.CumProfit;
				IsMaxProfitStopReached	=	false;
			}
			
//			if(SystemPerformance.AllTrades.TradesPerformance.Currency.CumProfit >= StrategyProfit && Quantity == EntryQuantity)
//			{
//				Quantity	=	Quantity * 10;
//			}
//			else if(SystemPerformance.AllTrades.TradesPerformance.Currency.CumProfit < StrategyProfit && Quantity != EntryQuantity)
//			{
//				Quantity	=	EntryQuantity;
//			}
			
			
			TradeLogic();
			
			
			if(buyYellow || sellYellow || buyPurple || sellPurple)
			{
				
				PlaceEntry(buyYellow||buyPurple, buyYellow || sellYellow);
			}
			
			
//			if(State == State.Historical)
//			{
//				DoTrailStop(stopOrder1,entryOrder1,Closes[0][0],0,0,1);
//			}
			
			
		}
		
		#endregion
		
		#region OnMarketData
		
		protected override void OnMarketData(MarketDataEventArgs marketDataUpdate)
		{
			if (marketDataUpdate.MarketDataType != MarketDataType.Last)
                return;
			
//			if(State == State.Realtime)
//			{
//				DoTrailStop(stopOrder1,entryOrder1,marketDataUpdate.Last,0,0,1);
//			}
			
		}
		
		#endregion
		
		#region OnOrderUpdate
		
		protected override void OnOrderUpdate(Order order, double limitPrice, double stopPrice, int quantity, int filled, double averageFillPrice, OrderState orderState, DateTime time, ErrorCode error, string nativeError)
        {
			
			if(order.Name.Contains("Entry1"))
			{
				if(order.OrderState==OrderState.Submitted)
				{
					entryOrder1 = order;
				}
			}
			
			if(order.Name.Contains("Entry2"))
			{
				if(order.OrderState==OrderState.Submitted)
				{
					entryOrder2 = order;
				}
			}
			
			if(order.Name.Contains("Entry3"))
			{
				if(order.OrderState==OrderState.Submitted)
				{
					entryOrder3 = order;
				}
			}
			
			
			if(order.Name.Contains("Stop1"))
			{
				if(order.OrderState==OrderState.Accepted)
				{
					stopOrder1 = order;
					// Add quantity to stop, if it is not correct
					ChangeOrder_AddStopQuant(stopOrder1,entryOrder1,1);
					
				}
				
				if(order.OrderState==OrderState.Rejected)
				{
					ClosePosition("Close Stop Was Rejected");
				}
			}
			
			if(order.Name.Contains("Stop2"))
			{
				if(order.OrderState==OrderState.Accepted)
				{
					stopOrder2 = order;
					// Add quantity to stop, if it is not correct
					ChangeOrder_AddStopQuant(stopOrder2,entryOrder2,2);
					
				}
				
				if(order.OrderState==OrderState.Rejected)
				{
					ClosePosition("Close Stop Was Rejected");
				}
			}
			
			if(order.Name.Contains("Stop3"))
			{
				if(order.OrderState==OrderState.Accepted)
				{
					stopOrder3 = order;
					// Add quantity to stop, if it is not correct
					ChangeOrder_AddStopQuant(stopOrder3,entryOrder3,3);
					
				}
				
				if(order.OrderState==OrderState.Rejected)
				{
					ClosePosition("Close Stop Was Rejected");
				}
			}
			
			if(order.Name.Contains("Profit1"))
			{
				if(order.OrderState==OrderState.Submitted)
				{
					profit1Order	=	order;
					
					ChangeOrder_AddProfitQuant(profit1Order,entryOrder1,1);
				}
			}
			
			if(order.Name.Contains("Profit2"))
			{
				if(order.OrderState==OrderState.Submitted)
				{
					profit2Order	=	order;
					
					ChangeOrder_AddProfitQuant(profit2Order,entryOrder2,2);
				}
			}
			
			if(order.Name.Contains("Profit3"))
			{
				if(order.OrderState==OrderState.Submitted)
				{
					profit3Order	=	order;
					
					ChangeOrder_AddProfitQuant(profit3Order,entryOrder3,3);
				}
			}
			
			
//			if(OrdersAreCancelled() && closeTradePerSessionPnl)
//			{
//				closeTradePerSessionPnl	=	false;
//				int profitstop			=	PerSessionPnlReachedProfitOrStop();
//				ClosePosition("Close "+(profitstop==1?"Max Profit Per Session":"Max Loss Per Session"));
//			}
			
			if(OrdersAreCancelled() && reverse && order!=null && entryOrder1==null)
			{

				
				
				reverse				=	false;
				OrderAction	oa		=	order.OrderAction;
				OrderType	ot		=	OrderType.Market;
				
				entryWasPlaced		=	true;
				tradeBar			=	CurrentBars[0]-idx;
				pos					=	oa==OrderAction.Buy ? 1 : 2;
				
				SubmitOrderUnmanaged(0,oa,ot,quantit,0,0,"",(oa==OrderAction.Buy ? "Buy " : "Sell ")+"Entry1");
			}
			
//			if(OrdersAreCancelled() && closePosition)
//			{
//				closePosition = false;
//				ClosePosition("Reverse Close");
//			}
			
		}
		
		#endregion
		
		#region OnExecutionUpdate
		
		protected override void OnExecutionUpdate(Execution execution, string executionId, double price, int quantity, MarketPosition marketPosition, string orderId, DateTime time)
		{
			
			
			
			bool	isLong	=	execution.Order.OrderAction==OrderAction.Buy;
			bool	filled	=	execution.Order.Filled == execution.Order.Quantity;
			
			if(execution.Name.Contains("Entry1"))
			{		
				
				OrderAction		oa				=	isLong?OrderAction.Sell:OrderAction.Buy;
				
//				InitStop(entryOrder1, stopOrder1,quantity, StopLoss, isLong, (isLong?"Long":"Short")+" Stop1", stopWasPlaced1,1);
				
				InitProfit(entryOrder1, profit1Order,quantity, PT, isLong,(isLong?"Long":"Short")+" Profit1",profit1WasPlaced,1);
				
//				PlaceEntrySLM(isLong);
			}
			
//			if(execution.Name.Contains("Entry2"))
//			{
//				InitStop(entryOrder2, stopOrder2,quantity, StopLoss2,isLong,(isLong?"Long":"Short")+" Stop2", stopWasPlaced2,2);
				
//				InitProfit(entryOrder2, profit2Order,quantity, PT2, isLong,(isLong?"Long":"Short")+" Profit2",profit2WasPlaced,2);
				
//				UpdateStopPrice(stopOrder1,isLong ? entryOrder2.AverageFillPrice - StopLoss1*TickSize : entryOrder2.AverageFillPrice + StopLoss1*TickSize);
				
//			}
			
//			if(execution.Name.Contains("Entry3"))
//			{
//				InitStop(entryOrder3, stopOrder3,quantity, StopLoss3,isLong,(isLong?"Long":"Short")+" Stop3", stopWasPlaced3,3);
				
//				InitProfit(entryOrder3, profit3Order,quantity, PT3, isLong,(isLong?"Long":"Short")+" Profit3",profit3WasPlaced,3);
				
//				UpdateStopPrice(stopOrder2,isLong ? entryOrder3.AverageFillPrice - StopLoss2*TickSize : entryOrder3.AverageFillPrice + StopLoss2*TickSize);
//				UpdateStopPrice(stopOrder1,isLong ? entryOrder3.AverageFillPrice - StopLoss1*TickSize : entryOrder3.AverageFillPrice + StopLoss1*TickSize);
//			}
			
			if(execution.Name.Contains("Stop1"))
			{
				if(Position.MarketPosition==MarketPosition.Flat)
				{
					ResetOrders();
				}
				else
				{
					if(filled && profit1Order!=null && profit1Order.OrderState!=OrderState.Cancelled && profit1Order.OrderState!=OrderState.Filled)
						CancelOrder(profit1Order);
					else
						UpdateProfitQuantity(profit1Order,profit1Order.Quantity-quantity);
				}
			}
			
//			if(execution.Name.Contains("Stop2"))
//			{
//				if(Position.MarketPosition==MarketPosition.Flat)
//				{
//					ResetOrders();
//				}
//				else
//				{
//					if(filled && profit2Order!=null && profit2Order.OrderState!=OrderState.Cancelled && profit2Order.OrderState!=OrderState.Filled)
//						CancelOrder(profit2Order);
//					else
//						UpdateProfitQuantity(profit2Order,profit2Order.Quantity-quantity);
//				}
//			}
			
//			if(execution.Name.Contains("Stop3"))
//			{
//				if(Position.MarketPosition==MarketPosition.Flat)
//				{
//					ResetOrders();
//				}
//				else
//				{
//					if(filled && profit3Order!=null && profit3Order.OrderState!=OrderState.Cancelled && profit3Order.OrderState!=OrderState.Filled)
//						CancelOrder(profit3Order);
//					else
//						UpdateProfitQuantity(profit3Order,profit3Order.Quantity-quantity);
//				}
//			}
			
			if(execution.Name.Contains("Profit1"))
			{
				if(Position.MarketPosition==MarketPosition.Flat)
				{
					ResetOrders();
				}
//				else
//				{
//					if(filled && stopOrder1!=null && stopOrder1.OrderState!=OrderState.Cancelled && stopOrder1.OrderState!=OrderState.Filled)
//						CancelOrder(stopOrder1);
//					else
//						UpdateProfitQuantity(stopOrder1,stopOrder1.Quantity-quantity);
//				}
			}
			
//			if(execution.Name.Contains("Profit2"))
//			{
//				if(Position.MarketPosition==MarketPosition.Flat)
//				{
//					ResetOrders();
//				}
//				else
//				{
//					if(filled && stopOrder2!=null && stopOrder2.OrderState!=OrderState.Cancelled && stopOrder2.OrderState!=OrderState.Filled)
//						CancelOrder(stopOrder2);
//					else
//						UpdateProfitQuantity(stopOrder2,stopOrder2.Quantity-quantity);
//				}
//			}
			
//			if(execution.Name.Contains("Profit3"))
//			{
//				if(Position.MarketPosition==MarketPosition.Flat)
//				{
//					ResetOrders();
//				}
//				else
//				{
//					if(filled && stopOrder3!=null && stopOrder3.OrderState!=OrderState.Cancelled && stopOrder3.OrderState!=OrderState.Filled)
//						CancelOrder(stopOrder3);
//					else
//						UpdateProfitQuantity(stopOrder3,stopOrder3.Quantity-quantity);
//				}
//			}
			
			if((execution.Name.Contains("Close")||execution.Name.Contains("Exit") 
				||execution.Name.Contains("Time End")||execution.Name.Contains("Stop Was Rejected")))
			{
				if(filled && Position.MarketPosition==MarketPosition.Flat)
				{
					if(execution.Name.Contains("Close Reversal"))
					{
						reverse	=	true;
					}
					
					ResetOrders();
					wasClosed = false;
					
					if(OrdersAreCancelled() && reverse)
					{
						
						reverse				=	false;
						OrderAction	oa		=	execution.MarketPosition==MarketPosition.Long?OrderAction.Buy:OrderAction.Sell;
						OrderType	ot		=	OrderType.Market;
						
						entryWasPlaced		=	true;
						tradeBar			=	CurrentBars[0]-idx;
						
						SubmitOrderUnmanaged(0,oa,ot,quantit,0,0,"",(oa==OrderAction.Buy ? "Buy " : "Sell ")+"Entry1");
					}
				}
				
				
			}
			
			
			
			

			
			
		}
		
		#endregion
		
		#region Trade Methods
		
		private	int	GetQuantity(double percent)
		{
			double 	cash		=	Account.GetAccountItem(AccountItem.CashValue,Currency.UsDollar).Value;
			double	cashPercent	=	cash * percent*0.01;
			
			return	(int)(cashPercent/Instrument.MasterInstrument.PointValue);
		}
		private void PlaceEntry(bool buy,bool yellowDot)
		{
			
			
			OrderAction 	oa			=	buy ? OrderAction.Buy : OrderAction.Sell;
			OrderType		ot			=	OrderType.Market;
			
			bool			reversal	=	(buy && Position.MarketPosition==MarketPosition.Short) ||
											(!buy && Position.MarketPosition==MarketPosition.Long);
			
							quantit		=	yellowDot ? GetQuantity(YellowDotQuantity) : GetQuantity(PurpleDotQuantity);
			
			bool			avgPrice	=	Position.MarketPosition == MarketPosition.Long ? Closes[0][0] > Position.AveragePrice : Closes[0][0] < Position.AveragePrice;
			
			if(quantit == 0)
				return;
			
			if(reversal && yellowDot && avgPrice)
			{
				ClosePosition("Close Reversal");
			}
			else if(!reversal && ((Position.MarketPosition==MarketPosition.Flat && yellowDot) || Position.MarketPosition!=MarketPosition.Flat))
//			if(entryOrder1==null && !entryWasPlaced && OrdersAreCancelled())
			{
				entryWasPlaced		=	true;
				tradeBar			=	CurrentBars[0]-idx;
				SubmitOrderUnmanaged(0,oa,ot,quantit,0,0,"",(buy ? "Buy " : "Sell ")+"Entry1");
			}
		}
		
		private	void TradeLogic()
		{
			if(CurrentBar < BarsRequiredToTrade)
				return;
			
			
			sellYellow			=	level3Semafor.HP_ZZ.IsValidDataPoint(idx) && !level3Semafor.HP_ZZ.IsValidDataPoint(idx+1) && level3Semafor[idx] >= Highs[0][idx] && bar0FT.IsFirstTick;
			
			buyYellow			=	level3Semafor.HP_ZZ.IsValidDataPoint(idx) && !level3Semafor.HP_ZZ.IsValidDataPoint(idx+1) && level3Semafor[idx] <= Lows[0][idx] && bar0FT.IsFirstTick;
			
			sellPurple			=	level3Semafor.NP_ZZ.IsValidDataPoint(idx) && !level3Semafor.NP_ZZ.IsValidDataPoint(idx+1) && level3Semafor[idx] >= Highs[0][idx] && bar0FT.IsFirstTick;
			
			buyPurple			=	level3Semafor.NP_ZZ.IsValidDataPoint(idx) && !level3Semafor.NP_ZZ.IsValidDataPoint(idx+1) && level3Semafor[idx] <= Lows[0][idx] && bar0FT.IsFirstTick;
			
			
		}
		
		private void ChangeOrder_AddStopQuant(Order StopOrder, Order EntryOrder, int stopType)
		{
			if((entryOrder1!=null && entryOrder1.OrderState==OrderState.Filled))
			{
				bool 	isbuy	=	entryOrder1.OrderAction==OrderAction.Buy;
				
				int		sQuant	=	stopType==1 ? addStopQuant1 : stopType==2 ? addStopQuant2 : addStopQuant3;
				
				if(StopOrder!=null && StopOrder.OrderState!=OrderState.Filled && StopOrder.OrderState!=OrderState.Cancelled)
				{
					if(sQuant != 0)
					{
						ChangeOrder(StopOrder,EntryOrder.Filled ,StopOrder.LimitPrice,StopOrder.StopPrice);
						if(stopType==1)
							addStopQuant1 = 0;
						else if(stopType==2)
							addStopQuant2 = 0;
						else if(stopType==3)
							addStopQuant3 = 0;
					}
				}
			}
		}
		
		private void ChangeOrder_AddProfitQuant(Order ProfitOrder, Order EntryOrder, int profitType)
		{
			if((entryOrder1!=null && entryOrder1.OrderState==OrderState.Filled))
			{
				bool 	isbuy	=	entryOrder1.OrderAction==OrderAction.Buy;
				
				int		pQuant	=	profitType==1 ? addProfitQuant1 : profitType==2 ? addProfitQuant2 : addProfitQuant3;
				
				if(ProfitOrder!=null && ProfitOrder.OrderState!=OrderState.Filled && ProfitOrder.OrderState!=OrderState.Cancelled)
				{
					if(pQuant != 0)
					{
						ChangeOrder(ProfitOrder,EntryOrder.Filled ,ProfitOrder.LimitPrice,ProfitOrder.StopPrice);
						if(profitType==1)
							addProfitQuant1 = 0;
						else if(profitType==2)
							addProfitQuant2 = 0;
						else if(profitType==3)
							addProfitQuant3 = 0;
					}
				}
			}
		}
		
//		private void InitStop(Order EntryOrder, Order StopOrder, int quantity, double Dollars, bool isLong, string name, bool stopWasPlaced, int stopType)
//		{
			
//			if(StopOrder==null && !stopWasPlaced)
//			{
//				if(stopType==1)
//					stopWasPlaced1				=	true;
//				else if(stopType==2)
//					stopWasPlaced2				=	true;
//				else if(stopType==3)
//					stopWasPlaced3				=	true;
				
//				OrderAction 	oa			=	isLong ? OrderAction.Sell : OrderAction.Buy;
//				double 			stpPrice 	=	isLong ? EntryOrder.AverageFillPrice - Dollars 
//														: EntryOrder.AverageFillPrice + Dollars;
				
//				SubmitOrderUnmanaged(0,oa,OrderType.StopMarket,quantity,stpPrice,stpPrice,"",name);
//			}
//			else if(StopOrder!=null && stopWasPlaced)
//			{
//				ChangeOrder(StopOrder,EntryOrder.Filled,StopOrder.LimitPrice,StopOrder.StopPrice);
//			}
//			else if(StopOrder==null && stopWasPlaced)
//			{
//				if(stopType==1)
//					addStopQuant1 += quantity;
//				else if(stopType==2)
//					addStopQuant2 += quantity;
//				else if(stopType==3)
//					addStopQuant3 += quantity;
						
//			}
			
//		}
		
		private void InitProfit(Order EntryOrder, Order ProfitOrder, int quantity, double Dollars, bool isLong, string name, bool profitWasPlaced, int profitType)
		{
			if(ProfitOrder==null && !profitWasPlaced)
			{
				OrderAction 	oa			=	isLong ? OrderAction.Sell : OrderAction.Buy;
				
				if(profitType==1)
					profit1WasPlaced		=	true;
				else if(profitType==2)
					profit2WasPlaced		=	true;
				else if(profitType==3)
					profit3WasPlaced		=	true;
					
				double	profitPrice	=	isLong ? EntryOrder.AverageFillPrice + Dollars : EntryOrder.AverageFillPrice - Dollars;
				SubmitOrderUnmanaged(0,oa,OrderType.Limit,quantity,profitPrice,0,"",name);
				
			}
			else if(ProfitOrder!=null && profitWasPlaced)
			{
				ChangeOrder(ProfitOrder,ProfitOrder.Quantity + quantity,ProfitOrder.LimitPrice,0);
			}
			else if(ProfitOrder==null && profitWasPlaced)
			{
				if(profitType==1)
					addProfitQuant1 += quantity;
				else if(profitType==2)
					addProfitQuant2 += quantity;
				else if(profitType==3)
					addProfitQuant3 += quantity;
			}
				
		}
		
		private void UpdateProfitQuantity(Order ProfitOrder, int Quantity)
		{
			if(ProfitOrder!=null && ProfitOrder.OrderState!=OrderState.Filled && ProfitOrder.OrderState!=OrderState.Cancelled)
			{
				ChangeOrder(ProfitOrder,Quantity,ProfitOrder.LimitPrice,ProfitOrder.StopPrice);
			}
		}
		
		private void UpdateStopQuantity(Order StopOrder, int Quantity)
		{
			if(StopOrder!=null && StopOrder.OrderState!=OrderState.Filled && StopOrder.OrderState!=OrderState.Cancelled)
			{
				ChangeOrder(StopOrder,Quantity,StopOrder.StopPrice,StopOrder.StopPrice);
			}
		}
		
		private	 void UpdateStopPrice(Order StopOrder, double Price)
		{
			if(StopOrder!=null && StopOrder.OrderState!=OrderState.Filled && StopOrder.OrderState!=OrderState.Cancelled)
			{
				ChangeOrder(StopOrder,StopOrder.Quantity,Price,Price);
			}
		}
		
		private void AddProfit(bool isLong)
		{
//			double 			profitPrice	=	isLong ? entryOrder1.AverageFillPrice + ProfitTarget1*TickSize : entryOrder1.AverageFillPrice - ProfitTarget1*TickSize;
//			OrderAction 	oa			=	isLong ? OrderAction.Sell : OrderAction.Buy;
			
//			SubmitOrderUnmanaged(0,oa,OrderType.Limit,1,profitPrice,0,"",(isLong?"Long":"Short")+" Profit"+(profitTargets.Count+1).ToString());
		}
		
		private int PnlTicks(Order entry, double close)
		{
			
			double pnl = 0;
			
			if(entry.OrderAction == OrderAction.Buy)
				pnl = close - entry.AverageFillPrice;
			if(entry.OrderAction == OrderAction.Sell)
				pnl = entry.AverageFillPrice - close;
			
			int pnl_ticks = (int)(Instrument.MasterInstrument.RoundToTickSize(pnl)/TickSize);
			
			return(pnl_ticks);
		}
		
//		private void DoTrailStop(Order StopOrder, Order EntryOrder, double close, double Dollars, double ProfitTrigger, int stopType)
//		{
			
//			if((EntryOrder!=null && EntryOrder.OrderState==OrderState.Filled))
//			{
//				bool 	isbuy			=	EntryOrder.OrderAction==OrderAction.Buy;
				
//				if(StopOrder!=null && StopOrder.OrderState!=OrderState.Filled && StopOrder.OrderState!=OrderState.Cancelled)
//				{
					
//					if((isbuy && close >= StopOrder.StopPrice + StopLoss + Frequency) ||
//						(!isbuy && close <= StopOrder.StopPrice - StopLoss - Frequency))
//					{
//						double 	newStop 	=	isbuy ? StopOrder.StopPrice + Frequency:StopOrder.StopPrice - Frequency;	
						
//						if((isbuy && newStop > StopOrder.StopPrice && close > newStop)||
//							(!isbuy && newStop < StopOrder.StopPrice && close < newStop))
//						{
//							ChangeOrder(StopOrder,StopOrder.Quantity,newStop,newStop);
//						}
//					}
					
					
//				}
//			}
//		}
		
		private void ResetOrders()
		{
			
			
			CancelAllOrders();
			
			
			slmEntryWasPlaced	=	false;
			
			entryOrder1 		= 	null;
			entryOrder2 		= 	null;
			entryOrder3 		= 	null;
			
			extbar				=	false;
			
			entryWasPlaced		=	false;
			stopWasPlaced1		=	false;
			stopWasPlaced2		=	false;
			stopWasPlaced3		=	false;
			profit1WasPlaced	=	false;
			profit2WasPlaced	=	false;
			profit3WasPlaced	=	false;
			wasClosed			=	false;
			wasTrailTrigger1	=	false;
			wasTrailTrigger2	=	false;
			wasTrailTrigger3	=	false;
			wasBreakeven		=	false;
			AddProfits			=	false;
			
			
			
			stopOrder1			=	null;
			stopOrder2			=	null;
			stopOrder3			=	null;
			
			profit1Order		=	null;
			profit2Order		=	null;
			profit3Order		=	null;
		}
		
		private class FirstTick
		{
			public bool IsFirstTick{get;set;}
			public int	CurrentBar{get;set;}
			public int	PreviousBar{get;set;}
			
			public FirstTick(int CurrentBar)
			{
				this.CurrentBar = CurrentBar;
			}
			
			public void Update(int CurrentBar)
			{
				this.CurrentBar = 	CurrentBar;
				IsFirstTick		=	PreviousBar < CurrentBar;
				PreviousBar 	= 	Math.Max(CurrentBar,PreviousBar);
			}
		}
		
		private void ClosePosition(Order entry,string name)
		{
			if(entry!=null && entry.OrderState==OrderState.Filled && !wasClosed)
			{
				wasClosed = true;
				OrderAction oa  = entry.OrderAction==OrderAction.Buy?OrderAction.Sell:OrderAction.Buy;
				SubmitOrderUnmanaged(0,oa,OrderType.Market,Position.Quantity,0,0,"",name);
			}
		}
		
		private void ClosePosition(string name)
		{
			if(Position!=null && Position.MarketPosition!=MarketPosition.Flat)
			{
				wasClosed = true;
				OrderAction oa  = Position.MarketPosition==MarketPosition.Long?OrderAction.Sell:OrderAction.Buy;
				SubmitOrderUnmanaged(0,oa,OrderType.Market,Position.Quantity,0,0,"",name);
			}
		}
		
		private void ExitPosition(string name, int quantity)
		{
			if(Position.MarketPosition!=MarketPosition.Flat)
			{
				OrderAction oa  = Position.MarketPosition == MarketPosition.Long ? OrderAction.Sell:OrderAction.Buy;
				SubmitOrderUnmanaged(0,oa,OrderType.Market,quantity,0,0,"",name);
			}
		}
		
//		private void AddPosition(bool buy)
//		{
//			if(Position.MarketPosition==MarketPosition.Flat)
//			{
//				PlaceEntry(buy);
//			}
//			else
//			{
//				OrderType		ot			=	OrderType.Market;
//				OrderAction 	oa			=	buy ? OrderAction.Buy : OrderAction.Sell;
//				SubmitOrderUnmanaged(0,oa,ot,1,0,0,"",(buy ? "Add Long " : "Add Short ")+"Entry");
//			}
//		}
		
		private	void BreakevenUpdate()
		{
//			if(entryOrder1!=null && entryOrder1.OrderState==OrderState.Filled)
//			{
//				if(stopOrder!=null && stopOrder.OrderState!=OrderState.Filled && stopOrder.OrderState!=OrderState.Cancelled)
//				{
//					if(!wasBreakeven && Breakeven != 0 && BreakevenFilter)
//					{
//						double pnl = PnlTicks(entryOrder1,Closes[0][0]);
						
//						if(pnl>=Breakeven)
//						{
//							double price	=	entryOrder1.OrderAction==OrderAction.Buy ? entryOrder1.AverageFillPrice + BreakevenOffset*TickSize : entryOrder1.AverageFillPrice - BreakevenOffset*TickSize;
//							lastTrailStop	=	price;
//							ChangeOrder(stopOrder,stopOrder.Quantity,price,price);
//							wasBreakeven = true;
//						}
//					}
//				}
//			}
		}
		
		
		private void CancelAllOrders()
		{
			if(stopOrder1!=null && stopOrder1.OrderState!=OrderState.Filled && stopOrder1.OrderState!=OrderState.Cancelled && stopOrder1.OrderState!=OrderState.Rejected)
			{
				CancelOrder(stopOrder1);
				stopOrder1	= 	null;
			}
			
			if(stopOrder2!=null && stopOrder2.OrderState!=OrderState.Filled && stopOrder2.OrderState!=OrderState.Cancelled && stopOrder2.OrderState!=OrderState.Rejected)
			{
				CancelOrder(stopOrder2);
				stopOrder2	= 	null;
			}
			
			if(stopOrder3!=null && stopOrder3.OrderState!=OrderState.Filled && stopOrder3.OrderState!=OrderState.Cancelled && stopOrder3.OrderState!=OrderState.Rejected)
			{
				CancelOrder(stopOrder3);
				stopOrder3	= 	null;
			}
			
			if(profit1Order!=null && profit1Order.OrderState!=OrderState.Filled && profit1Order.OrderState!=OrderState.Cancelled && profit1Order.OrderState!=OrderState.Rejected)
			{
				CancelOrder(profit1Order);
				profit1Order	= 	null;
			}
			
			if(profit2Order!=null && profit2Order.OrderState!=OrderState.Filled && profit2Order.OrderState!=OrderState.Cancelled && profit2Order.OrderState!=OrderState.Rejected)
			{
				CancelOrder(profit2Order);
				profit2Order	= 	null;
			}
			
			if(profit3Order!=null && profit3Order.OrderState!=OrderState.Filled && profit3Order.OrderState!=OrderState.Cancelled && profit3Order.OrderState!=OrderState.Rejected)
			{
				CancelOrder(profit3Order);
				profit3Order	= 	null;
			}
			
			if(entryOrder2!=null && entryOrder2.OrderState!=OrderState.Filled && entryOrder2.OrderState!=OrderState.Cancelled && entryOrder2.OrderState!=OrderState.Rejected)
			{
				CancelOrder(entryOrder2);
				entryOrder2	= 	null;
			}
			
			if(entryOrder3!=null && entryOrder3.OrderState!=OrderState.Filled && entryOrder3.OrderState!=OrderState.Cancelled && entryOrder3.OrderState!=OrderState.Rejected)
			{
				CancelOrder(entryOrder3);
				entryOrder3	= 	null;
			}
			
			
		}
		
		private bool OrdersAreCancelled()
		{
			
			if(stopOrder1!=null && stopOrder1.OrderState!=OrderState.Filled && stopOrder1.OrderState!=OrderState.Cancelled && stopOrder1.OrderState!=OrderState.Rejected)
			{
				return false;
			}
			
			if(stopOrder2!=null && stopOrder2.OrderState!=OrderState.Filled && stopOrder2.OrderState!=OrderState.Cancelled && stopOrder2.OrderState!=OrderState.Rejected)
			{
				return false;
			}
			
			if(stopOrder3!=null && stopOrder3.OrderState!=OrderState.Filled && stopOrder3.OrderState!=OrderState.Cancelled && stopOrder3.OrderState!=OrderState.Rejected)
			{
				return false;
			}
			
			
			if(profit1Order!=null && profit1Order.OrderState!=OrderState.Filled && profit1Order.OrderState!=OrderState.Cancelled && profit1Order.OrderState!=OrderState.Rejected)
			{
				return false;
			}
			
			if(profit2Order!=null && profit2Order.OrderState!=OrderState.Filled && profit2Order.OrderState!=OrderState.Cancelled && profit2Order.OrderState!=OrderState.Rejected)
			{
				return false;
			}
			
			if(profit3Order!=null && profit3Order.OrderState!=OrderState.Filled && profit3Order.OrderState!=OrderState.Cancelled && profit3Order.OrderState!=OrderState.Rejected)
			{
				return false;
			}
			
			if(entryOrder2!=null && entryOrder2.OrderState!=OrderState.Filled && entryOrder2.OrderState!=OrderState.Cancelled && entryOrder2.OrderState!=OrderState.Rejected)
			{
				return false;
			}
			
			if(entryOrder3!=null && entryOrder3.OrderState!=OrderState.Filled && entryOrder3.OrderState!=OrderState.Cancelled && entryOrder3.OrderState!=OrderState.Rejected)
			{
				return false;
			}
			
			return true;
		}
		
		#endregion
		
        #region TimeFilterClass

        public class TimeFilter
        {
            public TimeSpan StartTime { get; set; }
            public TimeSpan EndTime { get; set; }

            public bool Enabled { get; set; }

            public TimeFilter(TimeSpan StartTime, TimeSpan EndTime, bool Enabled)
            {
                this.StartTime = StartTime;
                this.Enabled = Enabled;
                this.EndTime = EndTime;
            }

            public bool IsValidTime(DateTime time)
            {
                TimeSpan dayTime = time.TimeOfDay;
                if (StartTime < EndTime)
                {
                    if (dayTime >= StartTime && dayTime <= EndTime)
                        return (true);
                }
                else if (StartTime > EndTime)
                {
                    if (dayTime >= StartTime || dayTime <= EndTime)
					{
                        return (true);
					}
                }
                else
				{
                    return (true);
				}

                return (false);
            }
        }
		
		bool IsNewTime(DateTime time0, DateTime time1)
		{
			if(timeFilters.Count == 0)
			{
				if(BarsArray[0].IsFirstBarOfSession)
				{
					return true;
				}
			}
			
			for (int i = 0; i < timeFilters.Count; i++)
            {
				if(time0.TimeOfDay > timeFilters[i].StartTime && time1.TimeOfDay <= timeFilters[i].EndTime)
				{
					return true;
					break;
				}
			}
			
			
			
			return false;
		}
		
		bool IsValidTime(DateTime time)
        {
            int disabledCount = 0;
			
            for (int i = 0; i < timeFilters.Count; i++)
            {
				
                if (!timeFilters[i].Enabled)
                {
                    disabledCount++;
                    continue;
                }
                if (timeFilters[i].Enabled )
                {
					
					if(timeFilters[i].IsValidTime(time))
                    return (true);
                }
            }


            if (disabledCount == timeFilters.Count)
                return (true);

            return (false);
        }

        #endregion
		
	}
	
}
